"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.erc20Balance = exports.ethBalance = exports.getProvider = void 0;
var bignumber_1 = require("@ethersproject/bignumber");
var contracts_1 = require("@ethersproject/contracts");
var providers_1 = require("@ethersproject/providers");
var detect_provider_1 = __importDefault(require("@metamask/detect-provider"));
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var T = __importStar(require("fp-ts/Task"));
var TE = __importStar(require("fp-ts/TaskEither"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var abi_1 = require("./abi");
var fp_1 = require("./fp");
var utils_1 = require("./utils");
exports.getProvider = function_1.pipe(fp_1.taskEitherWithError(function () { return detect_provider_1.default({ mustBeMetaMask: true }); }), TE.chain(function_1.flow(E.fromNullable(new Error('Ethereum provider not found, please install MetaMask')), TE.fromEither)), TE.map(function (provider) { return new providers_1.Web3Provider(provider); }));
exports.ethBalance = function (address, interval) {
    if (interval === void 0) { interval = 5000; }
    var balanceObs = new rxjs_1.Observable(function (subscriber) {
        var updateBalance = function (provider) {
            return subscriber.closed
                ? T.of(undefined)
                : function_1.pipe(fp_1.taskEitherWithError(function () { return provider.getBalance(address); }), TE.chain(function (balance) {
                    return TE.fromIO(function () { return subscriber.next({ balance: balance, decimal: utils_1.ethToken.data.decimals }); });
                }), TE.fold(function (e) { return T.fromIO(function () { return subscriber.error(e); }); }, function () { return function_1.pipe(updateBalance(provider), T.delay(interval)); }));
        };
        var run = function_1.pipe(exports.getProvider, TE.fold(function (e) { return T.fromIO(function () { return subscriber.error(e); }); }, updateBalance));
        run();
    });
    return function_1.pipe(balanceObs, operators_1.distinctUntilChanged(function (prev, curr) { return prev.balance.eq(curr.balance); }));
};
exports.erc20Balance = function (owner, tokenAddress, interval) {
    if (interval === void 0) { interval = 5000; }
    var balanceObs = new rxjs_1.Observable(function (subscriber) {
        var updateBalance = function (provider) {
            return subscriber.closed
                ? T.of(undefined)
                : function_1.pipe(fp_1.taskEitherWithError(function () { return __awaiter(void 0, void 0, void 0, function () {
                    var erc20Contract, _a, balance, decimal;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                erc20Contract = new contracts_1.Contract(tokenAddress, abi_1.erc20, provider);
                                return [4 /*yield*/, Promise.all([
                                        erc20Contract.balanceOf(owner),
                                        erc20Contract.decimals(),
                                    ])];
                            case 1:
                                _a = _b.sent(), balance = _a[0], decimal = _a[1];
                                return [2 /*return*/, { balance: bignumber_1.BigNumber.from(balance), decimal: decimal }];
                        }
                    });
                }); }), TE.chain(function (balanceObj) { return TE.fromIO(function () { return subscriber.next(balanceObj); }); }), TE.fold(function (e) { return T.fromIO(function () { return subscriber.error(e); }); }, function () { return function_1.pipe(updateBalance(provider), T.delay(interval)); }));
        };
        var run = function_1.pipe(exports.getProvider, TE.fold(function (e) { return T.fromIO(function () { return subscriber.error(e); }); }, updateBalance));
        run();
    });
    return function_1.pipe(balanceObs, operators_1.distinctUntilChanged(function (prev, curr) { return prev.balance.eq(curr.balance); }));
};
//# sourceMappingURL=etherium.js.map